'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var hooksCore = require('@midwayjs/hooks-core');

async function MidwayHooksLoader(source) {
  const callback = this.async();
  const root = hooksCore.getProjectRoot();
  const projectConfig = hooksCore.getConfig();
  const router = new hooksCore.FileRouter({
    root,
    projectConfig,
    useSourceFile: true
  });

  if (!router.isApiFile(this.resourcePath)) {
    return callback(null, source);
  }

  const route = router.getRoute(this.resourcePath);
  const Gateway = router.getGatewayByRoute(route);
  const client = await Gateway.createApiClient(this.resourcePath, source, new Gateway.router({
    root,
    projectConfig,
    useSourceFile: true
  }));
  callback(null, client);
}

exports.default = MidwayHooksLoader;
